Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_nuc_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_nuc_mod.F90	(revision 4743)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/strataer_nuc_mod.F90	(revision 4743)
@@ -0,0 +1,73 @@
+! $Id: strataer_nuc_mod.F90 3930 2021-06-11 19:39:09Z oboucher $
+MODULE strataer_nuc_mod
+! This module contains information about strato microphysic model nucleation parameters
+  
+  IMPLICIT NONE
+  
+CONTAINS
+  
+  ! Init all nucleation params
+  SUBROUTINE strataer_nuc_init()
+    
+    USE ioipsl_getin_p_mod, ONLY : getin_p
+    USE print_control_mod, ONLY : lunout
+    USE mod_phys_lmdz_para, ONLY : is_master
+    USE strataer_local_var_mod, ONLY: flag_nuc_rate_box,nuclat_min,nuclat_max,nucpres_min,nucpres_max
+    
+    !Config Key  = flag_nuc_rate_box
+    !Config Desc = define or not a box for nucleation rate
+    ! - F = global nucleation
+    ! - T = 2D-box for nucleation need nuclat_min, nuclat_max, nucpres_min and
+    ! nucpres_max
+    !       to define its bounds.
+    !Config Def  = F
+    !Config Help = Used in physiq.F
+    !
+    CALL getin_p('flag_nuc_rate_box',flag_nuc_rate_box)
+    CALL getin_p('nuclat_min',nuclat_min)
+    CALL getin_p('nuclat_max',nuclat_max)
+    CALL getin_p('nucpres_min',nucpres_min)
+    CALL getin_p('nucpres_max',nucpres_max)
+    
+    !============= Print params =============
+    IF (is_master) THEN
+       WRITE(lunout,*) 'IN STRATAER_NUC : flag_nuc_rate_box = ',flag_nuc_rate_box
+       IF (flag_nuc_rate_box) THEN
+          WRITE(lunout,*) 'IN STRATAER_NUC : nuclat_min = ',nuclat_min,', nuclat_max = ',nuclat_max
+          WRITE(lunout,*) 'IN STRATAER_NUC : nucpres_min = ',nucpres_min,', nucpres_max = ',nucpres_max
+       ENDIF
+    ENDIF ! if master
+    
+  END SUBROUTINE strataer_nuc_init
+  
+  ! Init aerosol tracers and large scale scavinging
+  SUBROUTINE tracstrataer_init(aerosol,lessivage)
+    
+    USE infotrac_phy, ONLY: nbtr, nbtr_sulgas, id_H2SO4_strat
+    USE ioipsl, ONLY : getin
+    USE print_control_mod, ONLY : lunout
+    
+    ! Output variables
+    LOGICAL,DIMENSION(nbtr), INTENT(INOUT) :: aerosol
+    LOGICAL,INTENT(INOUT)                  :: lessivage
+    INTEGER :: it
+    
+    ! Initialization
+    lessivage  =.TRUE.
+    aerosol(:) = .FALSE.
+    
+    DO it= 1, nbtr_sulgas
+       aerosol(it)=.FALSE.
+       IF (it==id_H2SO4_strat) aerosol(it)=.TRUE.
+    ENDDO
+    DO it= nbtr_sulgas+1, nbtr
+       aerosol(it)=.TRUE.
+    ENDDO
+    
+    !!jyg(20130206) : le choix d activation du lessivage est fait dans phytrac avec iflag_lscav
+!    CALL getin('lessivage',lessivage)
+    WRITE(lunout,*) 'IN TRACSTRATAER_INIT lessivage: ',lessivage
+    
+  END SUBROUTINE tracstrataer_init
+  
+END MODULE strataer_nuc_mod
Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratdistrib.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratdistrib.F90	(revision 4743)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratdistrib.F90	(revision 4743)
@@ -0,0 +1,68 @@
+!
+! $Id: stratemit.F90  2022-07-04 mmarchand $
+!
+SUBROUTINE STRATDISTRIB(altLMDz,altemiss,sigma_alt,f_lay_emiss)
+!
+  USE dimphy, ONLY : klon,klev
+  USE strataer_local_var_mod
+  USE YOMCST, only : RPI
+
+  IMPLICIT NONE
+
+! Input argument
+!---------------
+    REAL,DIMENSION(klev+1)  :: altLMDz    ! altitude of layer interfaces in m
+    REAL                    :: sigma_alt
+    REAL                    :: altemiss
+
+! Local variables
+!----------------
+    REAL                 :: f_lay_sum     ! sum of layer emission fractions
+    REAL                 :: alt
+    INTEGER              :: k,i_int
+    INTEGER,PARAMETER    :: n_int_alt=10  ! subintervals nb for integration over Gaussian emission
+
+! Output argument
+!----------------
+    REAL,DIMENSION(klev) :: f_lay_emiss   ! emiss fraction for every emiss for every vertical layer
+    
+    
+! Inject distrib
+!----------------
+    SELECT CASE(flag_emit_distrib)
+       
+    CASE(0) ! Gaussian distribution
+            ! Compute distribution of emission to vertical model layers
+            ! (based on Gaussian peak in altitude)
+       f_lay_sum=0.0
+       DO k=1, klev
+          f_lay_emiss(k)=0.0
+          DO i_int=1, n_int_alt
+             alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
+             f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt)* &
+                   & exp(-0.5*((alt-altemiss)/sigma_alt)**2.)* &           
+                   & (altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
+          ENDDO
+          f_lay_sum=f_lay_sum+f_lay_emiss(k)
+        ENDDO
+        
+     CASE(1) ! Uniform distribution
+             ! In this case, parameter sigma_alt is considered
+             ! to be half the
+             ! height of the injection, centered around altemiss)
+       f_lay_sum=0.0
+       DO k=1, klev
+          f_lay_emiss(k)=max(min(altemiss+sigma_alt,altLMDz(k+1))- &
+                      & max(altemiss-sigma_alt, &
+                      & altLMDz(k)),0.)/(2.*sigma_alt)
+          f_lay_sum=f_lay_sum+f_lay_emiss(k)
+       ENDDO
+
+       END SELECT        ! End CASE over flag_emit_distrib)
+       
+       WRITE(*,*) "IN stratdistrib f_lay_emiss=",f_lay_emiss
+
+       !correct for step integration error
+       f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
+
+END SUBROUTINE STRATDISTRIB
Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratemit.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratemit.F90	(revision 4743)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/stratemit.F90	(revision 4743)
@@ -0,0 +1,162 @@
+!
+! $Id: stratemit.F90  2022-07-04 mmarchand $
+!
+SUBROUTINE STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,tr_seri,&
+                    m_emiss_vol_daily,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_spec,&
+                    stretchlong,ispeci,id_species_total) 
+
+  USE dimphy, ONLY : klon,klev
+  USE strataer_local_var_mod
+  USE phys_cal_mod
+  USE phys_local_var_mod, ONLY: d_q_emiss
+  USE YOMCST, only : RD, RPI, RG
+  USE geometry_mod, ONLY : cell_area, boundslat
+  USE aerophys
+  USE infotrac_phy
+  USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon
+ 
+  IMPLICIT NONE
+
+! Input argument
+!---------------
+    REAL,INTENT(IN)    :: pdtphys, pdt               ! Pas d'integration pour la physique(seconde)
+    REAL,DIMENSION(klon),INTENT(IN)    :: xlat       ! latitudes pour chaque point
+    REAL,DIMENSION(klon),INTENT(IN)    :: xlon       ! longitudes pour chaque point
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: pplay
+    ! pression pour le mileu de chaque couche (en Pa)
+    REAL,DIMENSION(klon,klev+1),INTENT(IN) :: paprs
+    ! pression pour chaque inter-couche (en Pa)
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: t_seri ! Temperature
+    REAL,INTENT(IN)    :: latmin,latmax,lonmin,lonmax
+    REAL,INTENT(IN)    :: m_emiss_vol_daily          ! daily injection mass emission
+    REAL,INTENT(IN)    :: stretchlong                ! length to stretch emission (day)
+    REAL,DIMENSION(klon,klev) :: m_air_gridbox       ! mass ofair in every grid box[kg
+    REAL,INTENT(IN)     :: sigma_alt, altemiss
+    INTEGER,INTENT(IN)  :: id_spec, ispeci, id_species_total
+    
+! Output argument
+!----------------
+    REAL,DIMENSION(klon,klev,nbtr),INTENT(INOUT)  :: tr_seri ! Concentration Traceur [U/KgA]
+! Local variables
+!----------------
+    INTEGER              :: ieru, i, k, i_int, ilon, ilev
+    REAL                 :: dlat_loc
+    REAL,DIMENSION(klev+1)  :: altLMDz    ! altitude of layer interfaces in m
+    REAL                 :: zrho          ! Density of air [kg/m3]
+    REAL,DIMENSION(klev) :: zdm           ! mass of atm. model layer in kg  
+    REAL                 :: zdz           ! thickness of atm. model layer in m
+    REAL                 :: f_lay_sum     ! sum of layer emission fractions
+    REAL,DIMENSION(klev) :: f_lay_emiss   ! emiss fraction for every emiss for every vertical layer
+    REAL                 :: emission      ! emission
+    REAL                 :: theta_min, theta_max, theta ! for SAI computation between two latitudes
+    
+    IF (is_mpi_root) THEN
+       WRITE(*,*) 'IN STRATEMIT: date from phys_cal_mod=',year_cur,'-',&
+                      &  mth_cur,'-',day_cur,'-',hour,' flh2o=',flh2o
+    ENDIF
+
+!--calculate mass of air in every grid box !NL: DONE ABOVE DIRECTLY IN MAIN LOOP I,K
+!    DO ilon=1, klon
+!       DO ilev=1, klev
+!          m_air_gridbox(ilon,ilev)=(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG*cell_area(ilon)
+!       ENDDO
+!    ENDDO
+    
+    DO i=1,klon
+       
+       dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3))
+       dlon=360./2./FLOAT(nbp_lon) 
+       ! dlat = half difference of boundary latitudes
+       IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT, dlat=',dlat_loc,xlat(i),xlon(i)
+       
+       theta_min = max(xlat(i)-dlat_loc,latmin)
+       theta_max = min(xlat(i)+dlat_loc,latmax)
+                
+       IF (  xlat(i).GE.latmin-dlat_loc .AND. &
+         &   xlat(i).LT.latmax+dlat_loc .AND. &
+         &   xlon(i).GE.lonmin-dlon .AND. &
+         &   xlon(i).LT.lonmax+dlon ) THEN
+                   !
+          WRITE(*,*) 'coordinates of volcanic injection point=',&
+            &    xlat(i),xlon(i),day_cur,mth_cur,year_cur
+          WRITE(*,*) 'DD m_emiss_vol_daily=', &
+            &    m_emiss_vol_daily
+          
+          !compute altLMDz
+          altLMDz(:)=0.0
+          DO k=1, klev
+             zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
+             zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
+             zdz=zdm(k)/zrho                   !thickness of layer in m
+             altLMDz(k+1)=altLMDz(k)+zdz       !altitude of interface
+          ENDDO
+          
+          CALL STRATDISTRIB(altLMDz,altemiss,sigma_alt,f_lay_emiss)
+          
+          IF (flag_emit.EQ.3) then
+             theta=(sin(theta_max/180.*RPI)-sin(theta_min/180.*RPI))/ &
+               & (sin(xlat_max_sai/180.*RPI)-sin(xlat_min_sai/180.*RPI))
+          ELSE
+             theta=1.
+          ENDIF
+
+          !vertically distributed emission
+          DO k=1, klev
+            !--calculate mass of air in every grid box
+            m_air_gridbox(i,k)=(paprs(i,k)-paprs(i,k+1))/RG*cell_area(i)
+            ! stretch emission over stretchlong period
+            emission=m_emiss_vol_daily/m_air_gridbox(i,k)*f_lay_emiss(k)/stretchlong/ &
+                 &     (86400.-pdt)*theta
+            
+             IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT: emission avant/apres', &
+              &  'alt= ', altLMDz(k), &
+              &  'flh2o= ',flh2o, &
+              &  'id_speac= ',id_spec,id_species_total, &
+              &  'emission= ',emission, &
+              &  'pdtphys= ',pdtphys, &
+              &  'rapport m_emiss/m_air*f_lay= ', m_emiss_vol_daily/m_air_gridbox(i,k)*f_lay_emiss(k), &
+              &   'stretchlong= ', stretchlong, &
+              &   'theta= ', theta
+             
+             IF(emission < 1.E-34) emission = 0.0
+             
+             IF (flh2o.EQ.0) THEN
+                IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT: tr_ser avant/apres',&
+                  &  'i= ',i,'k= ',k, 'flh2o= ',flh2o, &
+                  &  tr_seri(i,k,id_spec), &
+                  &  tr_seri(i,k,id_spec)+emission*pdtphys
+              
+                tr_seri(i,k,id_spec)=tr_seri(i,k,id_spec)+emission*pdtphys
+                IF (id_species_total.NE.0) THEN
+                   tr_seri(i,k,id_species_total)=tr_seri(i,k,id_species_total)+emission*pdtphys
+                ENDIF
+             ELSE IF(flh2o.EQ.1) THEN
+                d_q_emiss(i,k)=emission*pdtphys
+                IF(d_q_emiss(i,k) > 1.E34) THEN
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) > 1.E34 = ',d_q_emiss(i,k)
+                ELSE IF(d_q_emiss(i,k) < -1.E34) THEN
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) < -1.E34 = ',d_q_emiss(i,k)
+                ENDIF
+                
+                IF(flag_verbose_strataer) WRITE(*,*) 'IN STRATEMIT: ',&
+                     &  'i= ',i,'k= ',k, 'flh2o= ',flh2o, &
+                     &  'emission= ',emission, &
+                     &  'd_q_emiss(i,k)= ',d_q_emiss(i,k)
+                
+                IF(d_q_emiss(i,k) > 1.E34) THEN
+                   d_q_emiss(i,k) = 1.E34
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) > 1.E34 : ',d_q_emiss(i,k)
+                ELSE IF(d_q_emiss(i,k) < -1.E34) THEN
+                   d_q_emiss(i,k) = -1.E34
+                   WRITE(*,*) 'IN STRATEMIT: d_q_emiss(i,k) < -1.E34 : ',d_q_emiss(i,k)
+                ENDIF
+             ENDIF
+             budg_emi(i,ispeci)=budg_emi(i,ispeci)+emission*zdm(k)
+          ENDDO
+          
+       ENDIF ! emission grid cell
+
+    ENDDO ! klon loop
+
+END SUBROUTINE STRATEMIT
Index: LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/traccoag_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/traccoag_mod.F90	(revision 4584)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/StratAer/traccoag_mod.F90	(revision 4743)
@@ -23,11 +23,11 @@
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_para, only: gather, scatter
-    USE phys_cal_mod, ONLY : year_len, mth_len, year_cur, mth_cur, day_cur, hour
+    USE phys_cal_mod, ONLY : year_len, year_cur, mth_cur, day_cur, hour
     USE sulfate_aer_mod
     USE phys_local_var_mod, ONLY: stratomask
     USE YOMCST
     USE print_control_mod, ONLY: lunout
-    USE strataer_mod
-
+    USE strataer_local_var_mod
+    
     IMPLICIT NONE
 
@@ -58,4 +58,5 @@
 !----------------
     REAL                                   :: m_aer_emiss_vol_daily ! daily injection mass emission
+    REAL                                   :: m_aer               ! aerosol mass
     INTEGER                                :: it, k, i, ilon, ilev, itime, i_int, ieru
     LOGICAL,DIMENSION(klon,klev)           :: is_strato           ! true = above tropopause, false = below
@@ -78,10 +79,14 @@
     REAL                                   :: theta_min, theta_max ! for SAI computation between two latitudes
     REAL                                   :: dlat_loc
+    REAL                                   :: latmin,latmax,lonmin,lonmax ! lat/lon min/max for injection
+    REAL                                   :: sigma_alt, altemiss ! injection altitude + sigma for distrib
+    REAL                                   :: pdt,stretchlong     ! physic timestep, stretch emission over one day
+    
     INTEGER                                :: injdur_sai          ! injection duration for SAI case [days]
     INTEGER                                :: yr, is_bissext
 
-    IF (is_mpi_root) THEN
+    IF (is_mpi_root .AND. flag_verbose_strataer) THEN
        WRITE(lunout,*) 'in traccoag: date from phys_cal_mod =',year_cur,'-',mth_cur,'-',day_cur,'-',hour
-       WRITE(lunout,*) 'IN traccoag flag_sulf_emit: ',flag_sulf_emit
+       WRITE(lunout,*) 'IN traccoag flag_emit: ',flag_emit
     ENDIF
     
@@ -126,20 +131,11 @@
 !--calculate mass of air in every grid box
     DO ilon=1, klon
-    DO ilev=1, klev
-      m_air_gridbox(ilon,ilev)=(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG*cell_area(ilon)
+       DO ilev=1, klev
+          m_air_gridbox(ilon,ilev)=(paprs(ilon,ilev)-paprs(ilon,ilev+1))/RG*cell_area(ilon)
+       ENDDO
     ENDDO
-    ENDDO
-
-!    IF (debutphy) THEN
-!      CALL gather(tr_seri, tr_seri_glo)
-!      IF (MAXVAL(tr_seri_glo).LT.1.e-30) THEN
-!--initialising tracer concentrations to zero
-!        DO it=1, nbtr
-!        tr_seri(:,:,it)=0.0
-!        ENDDO
-!      ENDIF
-!    ENDIF
-
+    
 !--initialise emission diagnostics
+    budg_emi(:,1)=0.0
     budg_emi_ocs(:)=0.0
     budg_emi_so2(:)=0.0
@@ -147,6 +143,6 @@
     budg_emi_part(:)=0.0
 
-!--sulfur emission, depending on chosen scenario (flag_sulf_emit)
-    SELECT CASE(flag_sulf_emit)
+!--sulfur emission, depending on chosen scenario (flag_emit)
+    SELECT CASE(flag_emit)
 
     CASE(0) ! background aerosol
@@ -159,71 +155,29 @@
           IF (year_cur==year_emit_vol(ieru).AND.mth_cur==mth_emit_vol(ieru).AND.&
                day_cur>=day_emit_vol(ieru).AND.day_cur<(day_emit_vol(ieru)+injdur)) THEN
-             !
-             ! daily injection mass emission - NL
-             m_aer_emiss_vol_daily = m_aer_emiss_vol(ieru)/(REAL(injdur)*REAL(ponde_lonlat_vol(ieru)))
-             WRITE(lunout,*) 'IN traccoag DD m_aer_emiss_vol(ieru)=',m_aer_emiss_vol(ieru), &
+
+             ! daily injection mass emission
+             m_aer=m_aer_emiss_vol(ieru,1)/(REAL(injdur)*REAL(ponde_lonlat_vol(ieru)))
+             !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
+             m_aer=m_aer*(mSO2mol/mSatom)
+             
+             WRITE(lunout,*) 'IN traccoag m_aer_emiss_vol(ieru)=',m_aer_emiss_vol(ieru,1), &
                   'ponde_lonlat_vol(ieru)=',ponde_lonlat_vol(ieru),'(injdur*ponde_lonlat_vol(ieru))', &
-                  (injdur*ponde_lonlat_vol(ieru)),'m_aer_emiss_vol_daily=',m_aer_emiss_vol_daily,'ieru=',ieru
+                  (injdur*ponde_lonlat_vol(ieru)),'m_aer_emiss_vol_daily=',m_aer,'ieru=',ieru
              WRITE(lunout,*) 'IN traccoag, dlon=',dlon
-             DO i=1,klon
-                !Pinatubo eruption at 15.14N, 120.35E
-                dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-                WRITE(lunout,*) 'IN traccoag, dlat=',dlat_loc
-                IF ( xlat(i).GE.xlat_min_vol(ieru)-dlat_loc .AND. xlat(i).LT.xlat_max_vol(ieru)+dlat_loc .AND. &
-                     xlon(i).GE.xlon_min_vol(ieru)-dlon .AND. xlon(i).LT.xlon_max_vol(ieru)+dlon ) THEN
-                   !
-                   WRITE(lunout,*) 'coordinates of volcanic injection point=',xlat(i),xlon(i),day_cur,mth_cur,year_cur
-                   WRITE(lunout,*) 'DD m_aer_emiss_vol_daily=',m_aer_emiss_vol_daily
-                   !         compute altLMDz
-                   altLMDz(:)=0.0
-                   DO k=1, klev
-                      zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
-                      zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
-                      zdz=zdm(k)/zrho                      !thickness of layer in m
-                      altLMDz(k+1)=altLMDz(k)+zdz          !altitude of interface
-                   ENDDO
-
-                   SELECT CASE(flag_sulf_emit_distrib)
-                   
-                   CASE(0) ! Gaussian distribution
-                   !compute distribution of emission to vertical model layers (based on Gaussian peak in altitude)
-                   f_lay_sum=0.0
-                   DO k=1, klev
-                      f_lay_emiss(k)=0.0
-                      DO i_int=1, n_int_alt
-                         alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                         f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt_vol(ieru))* &
-                              &              exp(-0.5*((alt-altemiss_vol(ieru))/sigma_alt_vol(ieru))**2.)*   &
-                              &              (altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                      ENDDO
-                      f_lay_sum=f_lay_sum+f_lay_emiss(k)
-                   ENDDO
-                   
-                   CASE(1) ! Uniform distribution
-                   ! In this case, parameter sigma_alt_vol(ieru) is considered to be half the
-                   ! height of the injection, centered around altemiss_vol(ieru)
-                   DO k=1, klev
-                      f_lay_emiss(k)=max(min(altemiss_vol(ieru)+sigma_alt_vol(ieru),altLMDz(k+1))- &
-                      & max(altemiss_vol(ieru)-sigma_alt_vol(ieru),altLMDz(k)),0.)/(2.*sigma_alt_vol(ieru))
-                      f_lay_sum=f_lay_sum+f_lay_emiss(k)
-                   ENDDO
-
-                   END SELECT        ! End CASE over flag_sulf_emit_distrib)
-
-                   WRITE(lunout,*) "IN traccoag m_aer_emiss_vol=",m_aer_emiss_vol(ieru)
-                   WRITE(lunout,*) "IN traccoag f_lay_emiss=",f_lay_emiss
-                   !correct for step integration error
-                   f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
-                   !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
-                   !vertically distributed emission
-                   DO k=1, klev
-                      ! stretch emission over one day of Pinatubo eruption
-                      emission=m_aer_emiss_vol_daily*(mSO2mol/mSatom)/m_air_gridbox(i,k)*f_lay_emiss(k)/1./(86400.-pdtphys)
-                      tr_seri(i,k,id_SO2_strat)=tr_seri(i,k,id_SO2_strat)+emission*pdtphys
-                      budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
-                   ENDDO
-                ENDIF ! emission grid cell
-             ENDDO ! klon loop
-             WRITE(lunout,*) "IN traccoag (ieru=",ieru,") m_aer_emiss_vol_daily=",m_aer_emiss_vol_daily
+             
+             latmin=xlat_min_vol(ieru)
+             latmax=xlat_max_vol(ieru)
+             lonmin=xlon_min_vol(ieru)
+             lonmax=xlon_max_vol(ieru)
+             altemiss = altemiss_vol(ieru)
+             sigma_alt = sigma_alt_vol(ieru)
+             pdt=pdtphys
+             ! stretch emission over one day of eruption
+             stretchlong = 1.
+             
+             CALL STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,tr_seri,&
+                  m_aer,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_SO2_strat, &
+                  stretchlong,1,0)
+             
           ENDIF ! emission period
        ENDDO ! eruption number
@@ -305,69 +259,24 @@
         .AND. ( day_emit_sai_start <= day_cur .OR. mth_emit_sai_start < mth_cur .OR. year_emit_sai_start < year_cur ) &
         .AND. ( day_cur <= day_emit_sai_end .OR. mth_cur < mth_emit_sai_end .OR. year_cur < year_emit_sai_end )) THEN
-
-     DO i=1,klon
-        dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-        IF  ( xlat(i).GE.xlat_sai-dlat_loc .AND. xlat(i).LT.xlat_sai+dlat_loc .AND. &
-          &   xlon(i).GE.xlon_sai-dlon .AND. xlon(i).LT.xlon_sai+dlon ) THEN
-!
-!         compute altLMDz
-          altLMDz(:)=0.0
-          DO k=1, klev
-            zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
-            zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
-            zdz=zdm(k)/zrho                      !thickness of layer in m
-            altLMDz(k+1)=altLMDz(k)+zdz          !altitude of interface
-          ENDDO
-
-          SELECT CASE(flag_sulf_emit_distrib)
-
-          CASE(0) ! Gaussian distribution
-          !compute distribution of emission to vertical model layers (based on Gaussian peak in altitude)
-          f_lay_sum=0.0
-               DO k=1, klev
-                     f_lay_emiss(k)=0.0
-                     DO i_int=1, n_int_alt
-                         alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                         f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt_sai)* &
-                         &              exp(-0.5*((alt-altemiss_sai)/sigma_alt_sai)**2.)*   & 
-                         &              (altLMDz(k+1)-altLMDz(k))/float(n_int_alt) 
-                     ENDDO
-                     f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          CASE(1) ! Uniform distribution
-          f_lay_sum=0.0
-          ! In this case, parameter sigma_alt_vol(ieru) is considered to be half
-          ! the height of the injection, centered around altemiss_sai
-               DO k=1, klev
-                    f_lay_emiss(k)=max(min(altemiss_sai+sigma_alt_sai,altLMDz(k+1))- &
-                    & max(altemiss_sai-sigma_alt_sai,altLMDz(k)),0.)/(2.*sigma_alt_sai)
-                    f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          END SELECT ! Gaussian or uniform distribution
-
-          !correct for step integration error
-          f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
-          !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
-          !vertically distributed emission
-          DO k=1, klev
-            ! stretch emission over whole year (360d)
-            emission=m_aer_emiss_sai*(mSO2mol/mSatom)/m_air_gridbox(i,k)*f_lay_emiss(k)/FLOAT(injdur_sai)/86400.  
-            tr_seri(i,k,id_SO2_strat)=tr_seri(i,k,id_SO2_strat)+emission*pdtphys
-            budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
-          ENDDO
-
-!          !emission as monodisperse particles with 0.1um dry radius (BIN21)
-!          !vertically distributed emission
-!          DO k=1, klev
-!            ! stretch emission over whole year (360d)
-!            emission=m_aer_emiss*(mH2SO4mol/mSatom)/m_part_dry(21)/m_air_gridbox(i,k)*f_lay_emiss(k)/FLOAT(year_len)/86400.
-!            tr_seri(i,k,id_BIN01_strat+20)=tr_seri(i,k,id_BIN01_strat+20)+emission*pdtphys 
-!            budg_emi_part(i)=budg_emi_part(i)+emission*zdm(k)*mSatom/mH2SO4mol
-!          ENDDO
-        ENDIF ! emission grid cell
-      ENDDO ! klon loop
-
+        
+       m_aer=m_aer_emiss_sai
+       !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
+       m_aer=m_aer*(mSO2mol/mSatom)
+       
+       latmin=xlat_sai
+       latmax=xlat_sai
+       lonmin=xlon_sai
+       lonmax=xlon_sai
+       altemiss = altemiss_sai
+       sigma_alt = sigma_alt_sai
+       pdt=0.
+       ! stretch emission over whole year (360d)
+       stretchlong=FLOAT(year_len)
+       
+       CALL STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,m_air_gridbox,tr_seri,&
+            m_aer,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_SO2_strat, &
+            stretchlong,1,0)
+       
+       budg_emi_so2(:) = budg_emi(:,1)*mSatom/mSO2mol
      ENDIF ! Condition over injection dates
 
@@ -375,75 +284,25 @@
             !     lat_min and lat_max
 
-    DO i=1,klon
-!       SAI scenario with continuous emission
-        dlat_loc=180./RPI/2.*(boundslat(i,1)-boundslat(i,3)) ! dlat = half difference of boundary latitudes
-        theta_min = max(xlat(i)-dlat_loc,xlat_min_sai)
-        theta_max = min(xlat(i)+dlat_loc,xlat_max_sai)
-        IF  ( xlat(i).GE.xlat_min_sai-dlat_loc .AND. xlat(i).LT.xlat_max_sai+dlat_loc .AND. &
-          &   xlon(i).GE.xlon_sai-dlon .AND. xlon(i).LT.xlon_sai+dlon ) THEN
-!
-!         compute altLMDz
-          altLMDz(:)=0.0
-          DO k=1, klev
-            zrho=pplay(i,k)/t_seri(i,k)/RD       !air density in kg/m3
-            zdm(k)=(paprs(i,k)-paprs(i,k+1))/RG  !mass of layer in kg
-            zdz=zdm(k)/zrho                      !thickness of layer in m
-            altLMDz(k+1)=altLMDz(k)+zdz          !altitude of interface
-          ENDDO
-
-          SELECT CASE(flag_sulf_emit_distrib)
-
-          CASE(0) ! Gaussian distribution
-          !compute distribution of emission to vertical model layers (based on
-          !Gaussian peak in altitude)
-          f_lay_sum=0.0
-               DO k=1, klev
-                     f_lay_emiss(k)=0.0
-                     DO i_int=1, n_int_alt
-                         alt=altLMDz(k)+float(i_int)*(altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                         f_lay_emiss(k)=f_lay_emiss(k)+1./(sqrt(2.*RPI)*sigma_alt_sai)* &
-                         & exp(-0.5*((alt-altemiss_sai)/sigma_alt_sai)**2.)*   &
-                         & (altLMDz(k+1)-altLMDz(k))/float(n_int_alt)
-                     ENDDO
-                     f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          CASE(1) ! Uniform distribution
-          f_lay_sum=0.0
-          ! In this case, parameter sigma_alt_vol(ieru) is considered to be half
-          ! the height of the injection, centered around altemiss_sai
-               DO k=1, klev
-                    f_lay_emiss(k)=max(min(altemiss_sai+sigma_alt_sai,altLMDz(k+1))- &
-                    & max(altemiss_sai-sigma_alt_sai,altLMDz(k)),0.)/(2.*sigma_alt_sai)
-                    f_lay_sum=f_lay_sum+f_lay_emiss(k)
-               ENDDO
-
-          END SELECT ! Gaussian or uniform distribution
-
-          !correct for step integration error
-          f_lay_emiss(:)=f_lay_emiss(:)/f_lay_sum
-          !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
-          !vertically distributed emission
-          DO k=1, klev
-            ! stretch emission over whole year (360d)
-            emission=m_aer_emiss_sai*(mSO2mol/mSatom)/m_air_gridbox(i,k)*f_lay_emiss(k)/ &
-                      & FLOAT(year_len)/86400.*(sin(theta_max/180.*RPI)-sin(theta_min/180.*RPI))/ & 
-                      & (sin(xlat_max_sai/180.*RPI)-sin(xlat_min_sai/180.*RPI))
-            tr_seri(i,k,id_SO2_strat)=tr_seri(i,k,id_SO2_strat)+emission*pdtphys
-            budg_emi_so2(i)=budg_emi_so2(i)+emission*zdm(k)*mSatom/mSO2mol
-          ENDDO
-
-!          !emission as monodisperse particles with 0.1um dry radius (BIN21)
-!          !vertically distributed emission
-!          DO k=1, klev
-!            ! stretch emission over whole year (360d)
-!            emission=m_aer_emiss*(mH2SO4mol/mSatom)/m_part_dry(21)/m_air_gridbox(i,k)*f_lay_emiss(k)/year_len/86400 
-!            tr_seri(i,k,id_BIN01_strat+20)=tr_seri(i,k,id_BIN01_strat+20)+emission*pdtphys 
-!            budg_emi_part(i)=budg_emi_part(i)+emission*zdm(k)*mSatom/mH2SO4mol
-!          ENDDO
-        ENDIF ! emission grid cell
-      ENDDO ! klon loop
-
-    END SELECT ! emission scenario (flag_sulf_emit)
+       m_aer=m_aer_emiss_sai
+       !emission as SO2 gas (with m(SO2)=64/32*m_aer_emiss)
+       m_aer=m_aer*(mSO2mol/mSatom)
+
+       latmin=xlat_min_sai
+       latmax=xlat_max_sai
+       lonmin=xlon_sai
+       lonmax=xlon_sai
+       altemiss = altemiss_sai
+       sigma_alt = sigma_alt_sai
+       pdt=0.
+       ! stretch emission over whole year (360d)
+       stretchlong=FLOAT(year_len)
+
+       CALL STRATEMIT(pdtphys,pdt,xlat,xlon,t_seri,pplay,paprs,m_air_gridbox,tr_seri,&
+            m_aer,latmin,latmax,lonmin,lonmax,altemiss,sigma_alt,id_SO2_strat, &
+            stretchlong,1,0)
+
+       budg_emi_so2(:) = budg_emi(:,1)*mSatom/mSO2mol
+       
+    END SELECT ! emission scenario (flag_emit)
 
 !--read background concentrations of OCS and SO2 and lifetimes from input file
@@ -463,5 +322,5 @@
     CALL coagulate(pdtphys,mdw,tr_seri,t_seri,pplay,dens_aer,is_strato)
 
-!--call sedimentation routine 
+!--call sedimentation routine
     CALL aer_sedimnt(pdtphys, t_seri, pplay, paprs, tr_seri, dens_aer)
 
@@ -480,10 +339,5 @@
       ENDDO
     ENDDO
-
-!    CALL minmaxsimple(tr_seri(:,:,id_SO2_strat),0.0,0.0,'fin SO2')
-!    DO it=1, nbtr_bin
-!      CALL minmaxsimple(tr_seri(:,:,nbtr_sulgas+it),0.0,0.0,'fin bin ')
-!    ENDDO
-
+    
   END SUBROUTINE traccoag
 
